%
% CPSC 424 Assignment 6 Question 2
%
% In this question, you will compute curvature, normals, tangents, and arc
% length for three curves given as parametric symbolic functions ([x1, y1],
% etc.).
%
% You can use Matlab's symbolic differentiation tools to help you
% compute these quantities.  The relevant command is diff(). The
% sumbolic integration tool int() can also be helpful. Alternatively,
% you can manually hardcode the formulas.
%
% You may also need to use the command matlabFunction() to convert
% symbolic functions into numerical functions that can be evaluated.
%
% Finally, to visualize the computed quantities you should pass them
% into the draw_curve_helper() function. The template code below
% visualizes some dummy values; you should replace them with the
% requested values.

% t-values range from 0 to 2
t_vals = reshape(0:0.01:2, [], 1);

% place holders for tangent, normal, arclength, and curvature.
placeholder_scalars = t_vals;
placeholder_vectors = ones( size(t_vals, 1), 2) * 0.1;

% Register t as a symbolic variable to allow symbolic differentiation
syms t



% ===================================================================
%                            Curve 1
% ===================================================================
x1 = t.^2;
y1 = 2*t;

% Evaluate curve
x_func = matlabFunction(x1); % Convert from symbolic to numerical function
y_func = matlabFunction(y1);
x = x_func(t_vals); % Evaluate numerical function at each t-value
y = y_func(t_vals);

% Compute curvature, arclength, tangents and normals at each t-value here.


% Draw the curve
figure(1);
draw_curve_helper([x, y], ...
                  placeholder_scalars, placeholder_scalars, ...
                  placeholder_vectors, placeholder_vectors);

% ===================================================================
%                            Curve 2
% ===================================================================

x2 = (t-1);
y2 = (t+1).^3;

% Evaluate curve
x_func = matlabFunction(x2); % Convert from symbolic to numerical function
y_func = matlabFunction(y2);
x = x_func(t_vals); % Evaluate numerical function at each t-value
y = y_func(t_vals);

% Compute curvature, arclength, tangents and normals at each t-value here.


% Draw the curve
figure(2);
draw_curve_helper([x, y], ...
                  placeholder_scalars, placeholder_scalars, ...
                  placeholder_vectors, placeholder_vectors);


% ===================================================================
%                            Curve 3
% ===================================================================

x3 = cos(t*pi/2.);
y3 = sin(t*pi);

% Evaluate curve
x_func = matlabFunction(x3); % Convert from symbolic to numerical function
y_func = matlabFunction(y3);
x = x_func(t_vals); % Evaluate numerical function at each t-value
y = y_func(t_vals);

% Compute curvature, arclength, tangents and normals at each t-value here.


% Draw the curve
figure(3);
draw_curve_helper([x, y], ...
                  placeholder_scalars, placeholder_scalars, ...
                  placeholder_vectors, placeholder_vectors);

% ======================================================================
%                      HELPER FUNCTIONS
% ======================================================================
function draw_curve_helper(pos, curvature, arclength, tangent, normal)
% function draw_curve_helper(x, curvature, arclength, tangent, normal)
%
% Draws a curve sampled at n points.
%
% pos is a n x 2 matrix with the point locations on the curve
% curvature is a vector of length n specifying the curvature at each x
% arclength is a vector of length n specifying the arclength at each x
% tangent is a matrix of size n x 2 specifying the tangent at each x
% normal is a matrix of size n x 2 specifying the normal at each x

% Make sure dimensions match
assert(size(pos,2) == 2);
assert(size(tangent,2) == 2);
assert(size(normal,2) == 2);
assert(size(pos,1) == size(tangent,1));
assert(size(pos,1) == size(normal,1));
assert(size(pos,1) == length(curvature));
assert(size(pos,1) == length(arclength));


% Draw curvature
subplot(2,2,1);
title('Curvature');
draw_curve_2D(pos, curvature);

% Draw arc-length
subplot(2,2,3);
title('Arc-length');
draw_curve_2D(pos, arclength);

% Draw normals
subplot(2,2,2);
title('Normals');
draw_curve_2D(pos, [], normal);

% Draw tangents
subplot(2,2,4);
title('Tangents');
draw_curve_2D(pos, [], tangent, 0.3); % minor disp

end

